<?php
function in_marray($needle = '', $haystack = '') {
	foreach ($haystack as $key => $value) {
		$return = in_array($needle, $haystack[$key]);
		if ($return == TRUE) {
			return TRUE;
		} 
	}
	return FALSE;
}

$bootstrap_settings['freepbx_auth'] = false;
// don't include any of the functions.inc.php files from modules, this CLI version of
// module_admin is somtimes the only way to recover from a bad module being loaded into
// a system.
//
$restrict_mods = array('core' => true);
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) {
	include_once('/etc/asterisk/freepbx.conf');
}

$admin_users = getAmpAdminUsers();
$admin_users_count = count($admin_users);

if (!$admin_users_count) {

  $vars = array(
    'action',
    'admin_user',
    'admin_pass1',
    'admin_pass2',
    'fop_pass1',
    'fop_pass2',
    'email_address1',
    'email_address2',
  );
  foreach ($vars as $var) {
    $$var = isset($_POST[$var]) ? trim($_POST[$var]) : '';
  }

  if ($action = 'add') {

    // TODO: Please Add Server Side validation here with some sort of error box that I think is already setup below
    //
    $freepbx_conf =& freepbx_conf::create();

    $admin_exists = in_marray($admin_user,$admin_users);
    if ($admin_user != '' && $admin_pass1 != '' && $admin_pass1 == $admin_pass2 && $admin_exists != TRUE) {
      core_ampusers_add($admin_user, $admin_pass1, '', '', '', array('*'));
      if ($freepbx_conf->conf_setting_exists('ARI_ADMIN_USERNAME') && $freepbx_conf->conf_setting_exists('ARI_ADMIN_PASSWORD')) {
        $freepbx_conf->set_conf_values(array('ARI_ADMIN_USERNAME' => $admin_user, 'ARI_ADMIN_PASSWORD' => $admin_pass1),true);
        $status = $freepbx_conf->get_last_update_status();
        if ($status['ARI_ADMIN_USERNAME']['saved']) {
          freepbx_log(FPBX_LOG_INFO,sprintf(_("OBE Initialize, set: [ARI_ADMIN_USERNAME] => [%s]"),$admin_user));
        }
        if ($status['ARI_ADMIN_PASSWORD']['saved']) {
          freepbx_log(FPBX_LOG_INFO,sprintf(_("OBE Initialize, set: [ARI_ADMIN_PASSWORD] => [%s]"),$admin_pass1));
        }
	if ($admin_pass1 != $freepbx_conf->get_conf_default_setting('ARI_ADMIN_PASSWORD')) {
 		$nt = notifications::create($db);
  		$nt->delete('ari', 'ARI_ADMIN_PASSWORD');
	}
	$nt->delete('freepbx', 'NEWMODS');
      }

	    if (($email_address1 != '' || $email_address2 != '') && $email_address1 == $email_address2) {
		    $cm =& cronmanager::create($db);
		    $cm->save_email($email_address1);
		    freepbx_log(FPBX_LOG_INFO,sprintf(_("OBE Initialize, set: [Module Admin Email] => [%s]"),$email_address1));
      }
      // All initialized so redirect back to the main page
      //
	    header('Location: /');

	  } else {
      //TODO: ok this is really part of server side validation, so put it all together above along with checking email address, etc.
      //
		  if ($admin_exists) {
        $error = "Admin User already exists, please try adding another admin user with a different name<br />";
      }
      if ($admin_user == '') {
        $error .= "Please enter an admin username<br />";
      }
      if ($admin_pass1 != $admin_pass2) {
        $error .= "Admin Password does not match<br />";
      }
      if ($admin_pass1 == '' | $admin_pass2 == '') {
        $error .= "Admin Password or the Retype is blank<br />";
      }
    }
  }

  $jquery_path = "admin/common/libfreepbx.javascripts.js";
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<title>FreePBX - First Install</title>
  <link rel="stylesheet" type="text/css" href="mainstyle.css" />
  <script type="text/javascript" src="<?php echo $jquery_path; ?>"></script>
  <script type="text/javascript">
  //<!--
  $(document).ready(function() {
    $("#submit").click(function(){
    if ($("#admin_user").val() == '' || $("#admin_pass1").val() == '' || $("#admin_pass1").val() != $("#admin_pass2").val()) {
      alert("Please provide a non-blank Admin user and password");
      return false;
    }
    if (($("#email_address1").val() != '' || $("#email_address2").val() != '') && $("#email_address1").val() != $("#email_address2").val()) {
      alert("Email Address is empty, not valid or does not match");
      return false;
    }
  });
  $("#admin_pass2").keyup(function(){
    var pass1 = $("#admin_pass1").val();
    var pass2 = $("#admin_pass2").val();
    if (pass1 != '' || pass2 != '') {
      if (pass1 == pass2) {
        $("#admin_pass2_icon").css({"background-image": "url('admin/images/validYes.png')"});
      } else {
        $("#admin_pass2_icon").css({"background-image": "url('admin/images/validNo.png')"});
      }
    } else {
      $("#admin_pass2_icon").css({"background-image": "none"});			
    }
  });
  $("#fop_pass2").keyup(function(){
    var pass1 = $("#fop_pass1").val();
    var pass2 = $("#fop_pass2").val();
    if (pass1 != '' || pass2 != '') {
      if (pass1 == pass2) {
        $("#fop_pass2_icon").css({"background-image": "url('admin/images/validYes.png')"});
      } else {
        $("#fop_pass2_icon").css({"background-image": "url('admin/images/validNo.png')"});
      }
    } else {
      $("#fop_pass2_icon").css({"background-image": "none"});			
    }
  });
  $("#email_address1").keyup(function(){
    var email = $("#email_address1").val();
      if (email != 0) {
        if (isValidEmailAddress(email)) {
          $("#email_address1_icon").css({"background-image": "url('admin/images/validYes.png')"});
        } else {
          $("#email_address1_icon").css({"background-image": "url('admin/images/validNo.png')"});
        }
      } else {
        $("#email_address1_icon").css({"background-image": "none"});			
      }
    });
    $("#email_address2").keyup(function(){
      var email1 = $("#email_address1").val();
      var email2 = $("#email_address2").val();
      if (email1 != '' || email2 != '') {
        if(email1 == email2) {
          $("#email_address2_icon").css({"background-image": "url('admin/images/validYes.png')"});
        } else {
          $("#email_address2_icon").css({"background-image": "url('admin/images/validNo.png')"});
        }
      } else {
        $("#email_address2_icon").css({"background-image": "none"});			
      }
    });
  });
  function isValidEmailAddress(emailAddress) {
    var pattern = /[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/;
    if (pattern.test(emailAddress) == false){
      $("#email_address1_icon").css({"background-image": "url('admin/images/validNo.png')"});
      return false;
    } else {
      return pattern.test(emailAddress);
    }
  }
  //-->
  </script>
  <style>
    .validate_icon {
      margin-top: 4px;
      margin-left: 9px;
      position: absolute;
      width: 16px;
      height: 16px;
    }
    .text {
      font-family: Arial, Tahoma, Helvetica;
    }
  </style>
    </head>
    <body>
		<form name='passwords' action="<?php echo $_SERVER['PHP_SELF']?> " method=POST>
		<input id="action" name="action" type="hidden" value="add">
		<table align="center" border="0" cellpadding="0" cellspacing="0" width="100%">
		  <tbody>
			<tr>
			  <td colspan="6" bgcolor="#6ea8d1" height="50">&nbsp;</td>
			  <td></td>
			</tr>
			
			<tr>
			  <td background="/admin/images/header-tile.jpg"><img src="/admin/images/header-bg-left.jpg" align="right" height="297" width="275"></td>
			  <td colspan="4" background="/admin/images/header-bg-tile.jpg" style="vertical-align: bottom;"><center><br /><b>Welcome to the FreePBX Distro.</b><br /></center></td>
			  <td background="/admin/images/header-tile.jpg"><img src="/admin/images/header-bg-right.jpg" align="left" height="297" width="275"></td>
			</tr>
		
			<tr>
			  <td colspan="1" rowspan="7"><img src="/admin/images/box-left.jpg" align="right" height="273" width="270"></td>
			  <td colspan="4" align="center" background="/admin/images/box-tile.jpg" valign="top"><br />To make sure your system is secure and there are no default passwords that could be compromised, please provide the core credentials that will be used to administer your system.<br /><br />
				<a class="info" href="javascript:void(null)">
                                Admin User:
                                <span style="left: -18px; display: none;">The admin username you supply will be used for both FreePBX and ARI.</span>
                                </a>
				<input id="admin_user" name="admin_user" placeholder="Admin Username" type="text" value="<?php echo $admin_user ?>">
			  </td>
			  <td colspan="1" rowspan="7"><img src="/admin/images/box-right.jpg" align="left" height="273" width="270"></td>
			</tr>
			
			<tr>
			  <td colspan="4" rowspan="1">&nbsp;</td>
			</tr>
			
			<tr>
			  <td align="center" valign="top">
				<a class="info" href="javascript:void(null)">
                                Admin Password:
                                <span style="left: -18px; display: none;">This field is used for the admin password for your FreePBX web interface.</span>
                                </a>
			  </td>
			  <td align="center" valign="top"><input id="admin_pass1" name="admin_pass1" placeholder="Admin Password" type="password" value="<?php echo $admin_pass1 ?>"></td>
			  <td align="center" valign="top">Admin Password Retype:</td>
			  <td align="center" valign="top"><input id="admin_pass2" name="admin_pass2" placeholder="Verify Password" type="password" value="<?php echo $admin_pass2 ?>"><span class="validate_icon" id="admin_pass2_icon"></span></td>
			</tr>
			
			<tr>
			  <td align="center" valign="top">
			  	<a class="info" href="javascript:void(null)">
                                Email Address:
                                <span style="left: -18px; display: none;">Email address where online updates will be sent. Leaving blank will result in no updates being sent. Also note that this email is never transmitted outside of your machine.</span>
                                </a>
			  </td>
			  <td align="center" valign="top"><input id="email_address1" name="email_address1" placeholder="Email Address" type="text" value="<?php echo $email_address1 ?>"><span class="validate_icon" id="email_address1_icon"></span></td>
			  <td align="center" valign="top">Email Address Retype:</td>
			  <td align="center" valign="top"><input id="email_address2" name="email_address2" placeholder="Verify Email Address" type="text" value="<?php echo $email_address2 ?>"><span class="validate_icon" id="email_address2_icon"></span></td>
			</tr>
			
			<tr>
			  <td align="center" valign="top" colspan="4" rowspan="1">
				<br />
				<input id="submit" name="submit" type="submit" value="Continue">
				</form>
			  </td>
			</tr>
			
			<tr>
			  <td align="center" background="/admin/images/box-bottom.png" valign="bottom" colspan="4" rowspan="1" height="40"></td>
			</tr>
			
			<tr>
			  <td colspan="6" bgcolor="#ffffff" height="100"><div id="error" style="color:red; text-align:center;">
				<?php
					if(isset($_POST['submit'])) {
						echo $error;
					}
				?>
			  </div></td>
			</tr>
			<tr>
			  <td colspan="6" align="center" bgcolor="#6ea8d1" height="100" valign="middle">
				  <p></p>
				  <p><font color="#ffffff" size="2">Powered by PBXact.com and FreePBX.org<br>Page Layout Copyright &copy; 2011 Schmoozecom.com, Inc.</font></p>
				  <p><font color="#ffffff" size="2">FreePBX	is a Registered Trademark of Bandwidth.com, All Rights Reserved<br>PBXact is a Registered Trademark of Schmooze Com, Inc., All Rights Reserved<br></font></p>
			  </td>
			</tr>
		  </tbody>
		</table>



</body>
</html>
<?php
} else {
//determine our panel path
$webroot = $amp_conf['AMPWEBROOT'];
$panel = $amp_conf['FOPWEBROOT'];
if (isset($panel) && $panel != '') {
	$panel = str_replace($webroot.'/', '', $panel);
	$menuOptions = 4;
} else {
	unset($panel);
	$menuOptions = 3;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<title>FreePBX-Distro</title>
</head>

<body>
<table width="100%" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td height="50" colspan="6" bgcolor="#6ea8d1">&nbsp;</td>
  </tr>
  <tr>
    <td background="admin/images/header-tile.jpg"><img src="admin/images/header-bg-left.jpg" width="275" height="297" align="right" /></td>
    <td colspan="<?php echo $menuOptions; ?>" background="admin/images/header-bg-tile.jpg">&nbsp;</td>
    <td background="admin/images/header-tile.jpg"><img src="admin/images/header-bg-right.jpg" width="275" height="297" align="left" /></td>
  </tr>
  <tr>
    <td><img src="admin/images/box-left.jpg" width="275" height="205" align="right" /></td>
    <td align="center" valign="top" background="admin/images/box-tile.jpg"><a href="admin/config.php" target="_freepbx"><img src="admin/images/sys-admin.png" width="150" height="145" border="0" /></a><br />
	PBX<br />
	Administrator
	</td>
    <td align="center" valign="top" background="admin/images/box-tile.jpg"><a href="recordings/" target="_ari"><img src="admin/images/user-control.png" width="150" height="145" border="0" /></a><br />
    User Control Panel<br />(ARI)</td>
<?php if(isset($panel)) { ?>
    <td align="center" valign="top" background="admin/images/box-tile.jpg"><a href="<?php echo $panel; ?>" target="_fop"><img src="admin/images/operator-panel.png" width="150" height="145" border="0" /></a><br />
    Operator Panel</td>
<?php } ?>
    <td align="center" valign="top" background="admin/images/box-tile.jpg"><a href="http://www.schmoozecom.com/oss.php" target="_support"><img src="admin/images/support.png" width="150" height="145" border="0" /></a><br />
    Get Official<br />FreePBX Support</td>
    <td><img src="admin/images/box-right.jpg" width="275" height="205" align="left" /></td>
  </tr>
  <tr>
    <td height="100" colspan="6" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>
  <tr>
    <td height="100" colspan="6" align="center" valign="middle" bgcolor="#6ea8d1">
      <p></p><p><font color="#FFFFFF" size="2">Powered by PBXact.com and FreePBX.org<br />
      Page Layout Copyright  &copy; 2011 - <?php echo date('Y'); ?> Schmoozecom.com, Inc.</font></p><p><font color="#FFFFFF" size="2">FreePBX is a Registered Trademark of Bandwidth.com, All Rights Reserved<br />
    PBXact is a Registered Trademark of Schmooze Com, Inc., All Rights Reserved<br /></font></p></td>
  </tr>
</table>
</body>
</html>
<?php
}

